#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## conf_func.pm for conf_func.pm
## 
## ######### PROJECT DESCRIPTION : ###
## 
## This file contains all functions for the configuration.
## 
## ###################################
## 
## Made by Boutonnet Alexandre
## Login   <aboutonnet@intellique.com>
## 
## Started on  Thu Jan 10 13:29:32 2008 Boutonnet Alexandre
## Last update Mon Jun  8 14:01:45 2009 Boutonnet Alexandre
## 
## ###################################
##

BEGIN
{
    my $conf_hash = {};
    sub _set_conf_hash { $conf_hash = shift }
    sub _get_conf_hash { return $conf_hash }
}

sub get_config
{
    my $conf_file = shift;

    if ( ! -r $conf_file)
    {
	print "Unable to read config file : $conf_file\nExiting.\n";
	exit(1);
    }

    # My personal config for Objet_logger
    my $conf_log = qq{
log4perl.logger                                     = WARN, LOG-WARN
log4perl.appender.LOG-WARN                          = Log::Log4perl::Appender::File
log4perl.appender.LOG-WARN.filename                 = /var/log/aspiq/core.log
log4perl.appender.LOG-WARN.layout                   = Log::Log4perl::Layout::PatternLayout
log4perl.appender.LOG-WARN.layout.ConversionPattern = %d [%p] %m %n
};

    my ($err, $OBJ_LOG) = new INTLIQ::Logger();
    if ($err) {
	print $OBJ_LOG."\n";
    } else {
	my $msg;
	($err, $msg) = $OBJ_LOG->set_conf(\$conf_log);
	if ($err) {
	    print "Unable to set_conf to INTLIQ::Logger : $msg\n";
	    exit(1);
	}
    }

    my $OBJ_CONF;
    ($err, $OBJ_CONF) = new INTLIQ::Conf($conf_file, $OBJ_LOG);
    if ($err) {
	print "Unable to instantiate INTLIQ::Conf : $OBJ_CONF\nExiting\n";
	exit(1);
    }

    my ($err, %hash_conf) = $OBJ_CONF->get_all();
    my $conf_hash = \%hash_conf;

    # Little hack for make this hash beautiful
    $conf_hash = $conf_hash->{'DEFAUTINTELLIQUEUNIQUE'};

    if (!keys(%{$conf_hash}))
    {
	print "Unable to get config options\nExiting.\n";
	exit(1);
    }

    _set_conf_hash($conf_hash);
}

sub get_config_option
{
    my $option = shift;

    my $hash = _get_conf_hash();

    return $hash->{$option};
}

###########
# Faire une fonction de valeurs par defaut
###########

1;
